"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var renderer_1 = require("./renderer");
var thisScript = Array.from(document.querySelectorAll("script")).pop();
var parent = typeof vscode != "undefined" ? vscode : window;
var renderer = new renderer_1.Renderer(String(thisScript.src)
    .split(":")
    .shift() + ":");
renderer.onMetaClick(function (element) {
    parent.postMessage({
        type: "metaElementClicked",
        sourceUri: element.sourceUri,
        sourceLocation: element.sourceLocation
    }, location.origin);
});
// need in iframe to ensure that styles are isolated
var iframe = document.createElement("iframe");
Object.assign(iframe.style, {
    width: "100%",
    height: "100%",
    border: "none"
});
iframe.onload = function () {
    var rootStyle = document.createElement("style");
    rootStyle.textContent = "\n    html, body {\n      margin: 0;\n      padding: 0;\n    }\n  ";
    iframe.contentWindow.document.body.appendChild(rootStyle);
    iframe.contentWindow.document.body.appendChild(renderer.mount);
};
document.body.appendChild(iframe);
var onMessage = function (_a) {
    var event = _a.data;
    renderer.handleEngineEvent(JSON.parse(event));
};
window.onmessage = onMessage;
